//
//
//  Created by Zefir Kurtisi on 10.05.2006.
//

#include "pa_interface.h"

 
/*
 * PA-Test: lese alles aus Audio-in- und schreibe in Audio-out-Buffer
 */
#define BLOCKS_IN_MS		10	// wir wollen in 10ms Bloecken arbeiten
#define SAMPLES_PER_BLOCK	(BLOCKS_IN_MS * SAMPLE_RATE / 1000)
#define BYTES_PER_BLOCK		(SAMPLES_PER_BLOCK*BYTES_PER_SAMPLE*CHANNELS)
void audio_loopback(void)
{
	char audio_buff[BYTES_PER_BLOCK];
	while(get_pa_input_samples() < SAMPLES_PER_BLOCK)
		usleep(5000); // warte je 5ms, bis genuegend Audiodaten vorhanden sind
	while(get_pa_input_samples() >= SAMPLES_PER_BLOCK)
		write_audio(audio_buff, read_audio(audio_buff, SAMPLES_PER_BLOCK));
}
 
 
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h>   // zum Umschalten der Tastatureingabe in non-blocking mode

int main(int argc, char **argv)
{
	init_portaudio();
	fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) | O_NONBLOCK);  // Tastatureingaben nicht blockierend
	printf("Starte PA-Loopback-Test. 'q' zum Beenden eingeben.\n");
	while(1)
	{
		if((char)getchar()=='q')
			break;
		audio_loopback();
	}
	printf("Schliesse Portaudio...\n");
	fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) & ~O_NONBLOCK);
	close_portaudio();
	return 0;
}
